package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.type.ByNameState;
import de.fhdw.wtf.common.ast.type.ByReferenceState;
import de.fhdw.wtf.common.ast.type.InvalidState;

/**
 * Exception Visitor for {@link de.fhdw.wtf.common.ast.type.TypeProxyState}.
 * 
 * @param <Y>
 *            ExceptionType
 */
public interface TypeProxyStateVisitorException<Y extends Exception> {
	
	/**
	 * Handle operations for the type {@link ByNameState}.
	 * 
	 * @param byName
	 *            {@link ByNameState}
	 * @throws Y
	 *             Y
	 */
	void handle(ByNameState byName) throws Y;
	
	/**
	 * Handle operations for the type {@link InvalidState}.
	 * 
	 * @param invalid
	 *            {@link InvalidState}.
	 * @throws Y
	 *             Y
	 */
	void handle(InvalidState invalid) throws Y;
	
	/**
	 * Handle operations for the type {@link ByReferenceState}.
	 * 
	 * @param byReference
	 *            {@link ByReferenceState}.
	 * @throws Y
	 *             Y
	 */
	void handle(ByReferenceState byReference) throws Y;
	
}
