package de.fhdw.wtf.common.constants.referencer;

import de.fhdw.wtf.common.exception.referencer.ConstructorReferencerExceptions;

/**
 * Contains Exceptions Messages for Referencer.
 */
public final class ExceptionConstans {
	
	/**
	 * The provided Type does not match to any given Types.
	 */
	public static final String INVALID_TYPE_REFERENCE_EXCEPTION_MESSAGE = "The provided Type does "
			+ "not match to any given Types: ";
	
	/**
	 * The refencer found exceptions in the abstract syntax tree.
	 */
	public static final String REFERENCING_NOT_SUCCESSFUL_EXCEPTION_MESSAGE = "The refencer found "
			+ "exceptions in the abstract syntax tree.";
	
	/**
	 * The provided TypeReference is not in ReferenceByName-State.
	 */
	public static final String WRONG_STATE_EXCEPTION_MESSAGE = "The provided TypeProxy " + "is not in ByNameState: ";
	
	/**
	 * Referenced constructors must exist.
	 */
	public static final String CONSTRUCTOR_REFERENCE_MISMATCH_MESSAGE = "No constructor matches with this reference.";
	
	/**
	 * Duplicate constructors should not exist because they cannot be referenced unambiguously.
	 */
	public static final String DUPLICATE_CONSTRUCOR_MESSAGE =
			"Found duplicate constructors while trying to match a constructor reference: ";
	
	/**
	 * COnstructors should only be called along a hierarchy.
	 */
	public static final String CYCLIC_CONSTRUCTOR_CALL_MESSAGE = "Cyclic constructor call found for: ";
	
	/**
	 * Exception message for {@link ConstructorReferencerExceptions}.
	 */
	public static final String CONSTRUCTOR_REFERENCER_EXCEPTION_OCCURED =
			"An exception occured when referencing constructors.";
	
	/**
	 * Constructor of {@link ExceptionConstans}.
	 */
	private ExceptionConstans() {
	}
	
}
