package de.fhdw.wtf.common.exception.parser;

import de.fhdw.wtf.common.token.Token;

/**
 * The {@link NoSquareBracketCloseException} will be thrown if a
 * {@link de.fhdw.wtf.common.token.symbols.SquareBracketCloseToken} is expected, but an another Token was found.
 * 
 */
public final class NoSquareBracketCloseException extends AbstractParserException {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = -4412670704704872180L;
	
	/**
	 * Constructor of {@link NoSquareBracketCloseException}.
	 * 
	 * @param token
	 *            token
	 * @param message
	 *            message
	 */
	private NoSquareBracketCloseException(final Token token, final String message) {
		super(token, message);
	}
	
	/**
	 * Creates a {@link NoSquareBracketCloseException}-Object.
	 * 
	 * @param token
	 *            token
	 * @return The {@link NoSquareBracketCloseException}-Object.
	 */
	public static NoSquareBracketCloseException create(final Token token) {
		return new NoSquareBracketCloseException(token,
				de.fhdw.wtf.common.constants.parser.ExceptionConstants.NO_SQUARE_BRACKET_CLOSE_EXCEPTION_MESSAGE);
	}
}
