package de.fhdw.wtf.common.exception.walker;

import de.fhdw.wtf.common.ast.Constructor;

/**
 * Represents the exception expressed through the existence of a duplicate constructor.
 */
public final class DuplicateConstructorException extends EditorMarkableConstructorException {
	
	/**
	 * Instantiates a {@link DuplicateConstructorException}.
	 * 
	 * @param constructor
	 *            duplicate constructor.
	 */
	private DuplicateConstructorException(final Constructor constructor) {
		super(constructor, de.fhdw.wtf.common.constants.walker.ExceptionConstants.DUPLICATE_CONSTRUCTOR_MESSAGE
				+ constructor.toStringWithoutSuperconstructors());
	}
	
	/**
	 * Instantiates a {@link DuplicateConstructorException}.
	 * 
	 * @param constructor
	 *            duplicate constructor.
	 * @return an instance of {@link DuplicateConstructorException}.
	 */
	public static DuplicateConstructorException create(final Constructor constructor) {
		return new DuplicateConstructorException(constructor);
	}
}
