package de.fhdw.wtf.common.exception.walker;

import de.fhdw.wtf.common.exception.editor.EditorMarkable;
import de.fhdw.wtf.common.exception.editor.EditorMarker;
import de.fhdw.wtf.common.token.Position;
import de.fhdw.wtf.common.token.Token;

public final class InvalidProductException extends TaskException implements EditorMarkable {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = -1525101684836730523L;
	private final Token firstToken;
	private final Token lastToken;
	
	private InvalidProductException(final String name, final Token firstToken, final Token lastToken) {
		super(de.fhdw.wtf.common.constants.walker.ExceptionConstants.INVALID_PRODUCT_MESSAGE + name);
		this.firstToken = firstToken;
		this.lastToken = lastToken;
	}
	
	public static InvalidProductException create(final String name, final Token firstToken, final Token lastToken) {
		return new InvalidProductException(name, firstToken, lastToken);
	}
	
	@Override
	public Position getStartPosition() {
		return this.firstToken.getPosition();
	}
	
	@Override
	public String getDescription() {
		return this.getMessage();
	}
	
	@Override
	public Position getEndPos() {
		return this.lastToken.getPosition();
	}
	
	@Override
	public EditorMarker getMarker() {
		return EditorMarker.INVALID_PRODUCT_MARKER;
	}
}
