package de.fhdw.wtf.common.token;

/**
 * This token signalizes the end of a stream.
 */
public class EndToken extends Token {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = 3907661300211152274L;
	/**
	 * Defines constant for hashCodeTemplate().
	 */
	private static final int HASHCODE_TEMPLATE_CONSTANT = 36298324;
	
	/**
	 * To-String of this class.
	 */
	private static final String TOSTRING = "";
	
	/**
	 * Private Constructor for EndToken. Use create(...)-Factory instead!
	 * 
	 * @param position
	 *            start position of this token in the original input.
	 */
	protected EndToken(final Position position) {
		super(position);
	}
	
	/**
	 * Factory for a {@link EndToken}.
	 * 
	 * @param position
	 *            start position of this token in the original input.
	 * @return a new instance of this token
	 */
	public static EndToken create(final Position position) {
		return new EndToken(position);
	}
	
	@Override
	public boolean isEndToken() {
		return true;
	}
	
	@Override
	protected boolean equalsTemplate(final Token t) {
		return t.isEndToken();
	}
	
	@Override
	protected int hashCodeTemplate() {
		return HASHCODE_TEMPLATE_CONSTANT;
	}
	
	@Override
	public boolean equals(final Object o) {
		if (o instanceof EndToken) {
			return super.equals(o);
		}
		return false;
	}
	
	@Override
	public int hashCode() {
		return super.hashCode();
	}
	
	@Override
	public String stringRepresentation() {
		return TOSTRING;
	}
	
	@Override
	public int getLength() {
		return 0;
	}
	
}
