package de.fhdw.wtf.dsl.scanner.common;

import de.fhdw.wtf.common.token.Position;

/**
 * Interface for {@link ScannerState} creation.
 * 
 * Used to write anonymous Classes for {@link Delta} creation.
 * 
 */
public interface StateCreater {
	
	/**
	 * Returns a new {@link ScannerState} with given position.
	 * 
	 * @param position
	 *            Position of the new {@link ScannerState}
	 * @return created {@link ScannerState}
	 */
	ScannerState create(Position position);
}
